Cantera 2.6.0

Public Member Functions | Public Attributes | Protected Attributes | List of all members
FalloffData Struct Reference

Data container holding shared data specific to Falloff rates. More...

`#include <Falloff.h>`

Inheritance diagram for FalloffData:
[legend]
Collaboration diagram for FalloffData:
[legend]

## Public Member Functions
virtual bool | update (const ThermoPhase &phase, const Kinetics &kin) override
| Update data container based on thermodynamic phase state. More...
virtual void | update (double T) override
| Update data container based on temperature T More...
virtual void | update (double T, double M) override
| Update data container based on temperature T and an extra parameter. More...
void | perturbThirdBodies (double deltaM)
| Perturb third-body concentration vector of data container. More...
virtual void | restore () override
| Restore data container after a perturbation. More...
virtual void | resize (size_t nSpecies, size_t nReactions, size_t nPhases) override
| Update number of species, reactions and phases. More...
virtual void | invalidateCache () override
| Force shared data and reaction rates to be updated next time. More...
virtual void | update (double T)
| Update data container based on temperature T More...
virtual void | update (double T, double extra)
| Update data container based on temperature T and an extra parameter. More...
virtual void | update (double T, const vector_fp &extra)
| Update data container based on temperature T and a vector parameter extra More...
virtual bool | update (const ThermoPhase &phase, const Kinetics &kin)=0
| Update data container based on thermodynamic phase state. More...
Public Member Functions inherited from ReactionData
virtual void | update (double T)
| Update data container based on temperature T More...
virtual void | update (double T, double extra)
| Update data container based on temperature T and an extra parameter. More...
virtual void | update (double T, const vector_fp &extra)
| Update data container based on temperature T and a vector parameter extra More...
virtual bool | update (const ThermoPhase &phase, const Kinetics &kin)=0
| Update data container based on thermodynamic phase state. More...
void | perturbTemperature (double deltaT)
| Perturb temperature of data container. More...
virtual void | restore ()
| Restore data container after a perturbation. More...
virtual void | resize (size_t nSpecies, size_t nReactions, size_t nPhases)
| Update number of species, reactions and phases. More...
virtual void | invalidateCache ()
| Force shared data and reaction rates to be updated next time. More...

## Public Attributes
bool | ready
| boolean indicating whether vectors are accessible More...
double | molar_density
| used to determine if updates are needed More...
vector_fp | conc_3b
| vector of effective third-body concentrations More...
Public Attributes inherited from ReactionData
double | temperature
| temperature More...
double | logT
| logarithm of temperature More...
double | recipT
| inverse of temperature More...

## Protected Attributes
int | m_state_mf_number
| integer that is incremented when composition changes More...
bool | m_perturbed
| boolean indicating whether 3-rd body values are perturbed More...
vector_fp | m_conc_3b_buf
| buffered third-body concentrations More...
Protected Attributes inherited from ReactionData
double | m_temperature_buf
| buffered temperature More...

## Detailed Description

Data container holding shared data specific to Falloff rates.

The data container `FalloffData` holds precalculated data common to all Falloff related reaction rate classes.

Definition at line 30 of file Falloff.h.

## Constructor & Destructor Documentation

## ◆ FalloffData()

FalloffData | ( |  | ) |

Definition at line 20 of file Falloff.cpp.

## Member Function Documentation

## ◆ update() [1/7]

bool update | ( | const ThermoPhase & | phase,
|  | const Kinetics & | kin
| ) |  |
| override virtual

Update data container based on thermodynamic phase state.

This update mechanism is used by Kinetics reaction rate evaluators.

Returns
  A boolean element indicating whether the `evalFromStruct` method needs to be called (assuming previously-calculated values were cached)

Implements ReactionData.

Definition at line 42 of file Falloff.cpp.

References Phase::molarDensity(), and Phase::stateMFNumber().

## ◆ update() [2/7]

void update | ( | double | T | ) |
| override virtual

Update data container based on temperature T

Only used in conjunction with MultiRateBase::evalSingle / ReactionRate::eval. This method allows for testing of a reaction rate expression outside of Kinetics reaction rate evaluators.

Reimplemented from ReactionData.

Definition at line 30 of file Falloff.cpp.

## ◆ update() [3/7]

void update | ( | double | T,
|  | double | extra
| ) |  |
| override virtual

Update data container based on temperature T and an extra parameter.

Only used in conjunction with MultiRateBase::evalSingle / ReactionRate::eval. This method allows for testing of a reaction rate expression outside of Kinetics reaction rate evaluators.

Reimplemented from ReactionData.

Definition at line 36 of file Falloff.cpp.

## ◆ perturbThirdBodies()

void perturbThirdBodies | ( | double | deltaM | ) |

Perturb third-body concentration vector of data container.

The method is used for the evaluation of numerical derivatives.

Parameters

  deltaM | relative third-body perturbation

Definition at line 61 of file Falloff.cpp.

## ◆ restore()

void restore | ( |  | ) |
| override virtual

Restore data container after a perturbation.

Reimplemented from ReactionData.

Definition at line 74 of file Falloff.cpp.

## ◆ resize()

virtual void resize | ( | size_t | nSpecies,
|  | size_t | nReactions,
|  | size_t | nPhases
| ) |  |
| inline override virtual

Update number of species, reactions and phases.

Reimplemented from ReactionData.

Definition at line 51 of file Falloff.h.

References FalloffData::conc_3b, FalloffData::m_conc_3b_buf, and FalloffData::ready.

## ◆ invalidateCache()

virtual void invalidateCache | ( |  | ) |
| inline override virtual

Force shared data and reaction rates to be updated next time.

This is called by functions that change quantities affecting rate calculations that are normally assumed to be constant, like the reaction rate parameters or the number of reactions.

Reimplemented from ReactionData.

Definition at line 57 of file Falloff.h.

References ReactionData::invalidateCache(), and FalloffData::molar_density.

## ◆ update() [4/7]

virtual void update | ( | double | T | ) |
| inline virtual

Update data container based on temperature T

Only used in conjunction with MultiRateBase::evalSingle / ReactionRate::eval. This method allows for testing of a reaction rate expression outside of Kinetics reaction rate evaluators.

Reimplemented from ReactionData.

Definition at line 35 of file ReactionData.h.

## ◆ update() [5/7]

virtual void update | ( | double | T,
|  | double | extra
| ) |  |
| inline virtual

Update data container based on temperature T and an extra parameter.

Only used in conjunction with MultiRateBase::evalSingle / ReactionRate::eval. This method allows for testing of a reaction rate expression outside of Kinetics reaction rate evaluators.

Reimplemented from ReactionData.

Definition at line 47 of file ReactionData.h.

## ◆ update() [6/7]

virtual void update | ( | double | T,
|  | const vector_fp & | extra
| ) |  |
| inline virtual

Update data container based on temperature T and a vector parameter extra

Only used in conjunction with MultiRateBase::evalSingle / ReactionRate::eval. This method allows for testing of a reaction rate expression outside of Kinetics reaction rate evaluators.

Warning
  This method is an experimental part of the Cantera API and may be changed or removed without notice.

Reimplemented from ReactionData.

Definition at line 61 of file ReactionData.h.

## ◆ update() [7/7]

virtual bool update | ( | const ThermoPhase & | phase,
|  | const Kinetics & | kin
| ) |  |
| virtual

Update data container based on thermodynamic phase state.

This update mechanism is used by Kinetics reaction rate evaluators.

Returns
  A boolean element indicating whether the `evalFromStruct` method needs to be called (assuming previously-calculated values were cached)

Implements ReactionData.

## Member Data Documentation

## ◆ ready

bool ready

boolean indicating whether vectors are accessible

Definition at line 62 of file Falloff.h.

Referenced by FalloffRate::evalFromStruct(), and FalloffData::resize().

## ◆ molar_density

double molar_density

used to determine if updates are needed

Definition at line 63 of file Falloff.h.

Referenced by FalloffData::invalidateCache().

## ◆ conc_3b

vector_fp conc_3b

vector of effective third-body concentrations

Definition at line 64 of file Falloff.h.

Referenced by FalloffRate::evalFromStruct(), and FalloffData::resize().

## ◆ m_state_mf_number

int m_state_mf_number
| protected

integer that is incremented when composition changes

Definition at line 67 of file Falloff.h.

## ◆ m_perturbed

bool m_perturbed
| protected

boolean indicating whether 3-rd body values are perturbed

Definition at line 68 of file Falloff.h.

## ◆ m_conc_3b_buf

vector_fp m_conc_3b_buf
| protected

buffered third-body concentrations

Definition at line 69 of file Falloff.h.

Referenced by FalloffData::resize().

The documentation for this struct was generated from the following files:

- Falloff.h
- Falloff.cpp